#include "stdafx.h"
#include <stdlib.h>
#include "naverutil.h"
#include <Tlhelp32.h>
#include <shlobj.h>
#include <atlrx.h>
#include "ModuleInstance.h"
#define FAVICON_URL _T ( "http://www.naver.com/favicon.ico" )
#define SEARCH_URL _T( "http://search.naver.com/search.naver?where=nexearch&sm=ies_hty&query={searchTerms}" )
#define SUGGESTION_URL_JASON _T ( "http://ac.search.naver.com/autocompl?m=s&q={searchTerms}&oe={outputEncoding}" ) 

#define SEARCH_URL_FOR_MS _T ( "http://search.naver.com/search.naver?where=nexearch&sm=osd&query={searchTerms}" )

const TCHAR *g_szInvalidSearchUrl[] = {
										{ _T( "http://search.naver.com/search.naver?where=nexearch&sm=ies_hty&ie=utf8&query={searchTerms}" ) },
										{ _T( "http://rd.search.naver.com/search.naver?where=nexearch&sm=ies_hty&ie=utf8&query={searchTerms}" ) },
										{ _T( "http://search.naver.com/search.naver?where=nexearch&sm=osd&ie={inputEncoding}&query={searchTerms}" ) },
										{ _T( "http://search.naver.com/search.naver?where=nexearch&sm=osd&query={searchTerms}" ) },
										{ _T( "http://search.naver.com/search.naver?where=nexearch&sm=ies_hty&query={searchTerms}" ) }
									  };

#define MAX_INVALID_URL_COUNT 5
#define MS_GALLERY_URL_NO 2

#define SHOW_SEARCH_SUGGESTION 1
#define CODE_PAGE 949

BOOL CUtil::IsIEVersion70()
{
	CRegKey regkey;
	if ( regkey.Open(HKEY_LOCAL_MACHINE, _T("SOFTWARE\\Microsoft\\Internet Explorer\\Version Vector"), KEY_READ ) != ERROR_SUCCESS )
		return FALSE;

	TCHAR szIEVersion[MAX_PATH];
	ULONG ulSize = MAX_PATH;
	regkey.QueryStringValue(_T("IE"), szIEVersion, &ulSize);

	if ( szIEVersion[0] >= _T('7') )
		return TRUE;
	else
		return FALSE;
}

/**
 *  Ÿ  Ȯ
 * @return Ÿ̸ TRUE, ƴϸ FALSE
*/
BOOL CUtil::IsWinVista()
{
	OSVERSIONINFO  osver;
	osver.dwOSVersionInfoSize = sizeof ( osver );
	GetVersionEx ( &osver );
	
	if ( osver.dwPlatformId == VER_PLATFORM_WIN32_NT && osver.dwMajorVersion >= 6 )
	{
		return TRUE;
	}
	
	else
	{
		return FALSE;
	}
}

/**
 * IE û ̻ Ȯϴ Լ
 * @return û ̻  TRUE, ƴϸ FALSE
*/
BOOL CUtil::IsIEVersionRequiredOrHigherVer ( const double dRequiredVersion )
{
	CRegKey regkey;
	
	if ( regkey.Open ( HKEY_LOCAL_MACHINE, _T ( "SOFTWARE\\Microsoft\\Internet Explorer\\Version Vector" ) ) != ERROR_SUCCESS )
		return FALSE;
		
	TCHAR szIEVersion[MAX_PATH] = {0, };
	
	ULONG nChars = MAX_PATH;
	
	if ( ERROR_SUCCESS == regkey.QueryStringValue ( _T ( "IE" ), szIEVersion, &nChars ) )
	{
		double ieVer = _tstof ( szIEVersion );
		
		if ( ieVer >= dRequiredVersion )
			return TRUE;
		else
			return FALSE;
	}
	
	else
		return FALSE;
}

/**
 * ڷ ־ μ ڵ μ ڸ , Ÿ  ȣȴ.
 * @param phProcess - ڸ  μ ڵ
 * @param sname - ڸ   ( ũ⸦ 300 ´)
 * @param bIncDoman -    
 * @return ڸ ãµ ̸ TRUE, ƴϸ FALSE
 */
BOOL CUtil::GetProcessUsername ( HANDLE *phProcess, TCHAR* sname, BOOL bIncDomain )
{
	HANDLE tok = 0;
	HANDLE hProcess;
	TOKEN_USER *ptu;
	DWORD nlen, dlen;
	TCHAR name[300], dom[300], tubuf[300];
	int iUse;
	
	BOOL ret = FALSE;
	
	//if phProcess is NULL we get process handle of this
	//process.
	hProcess = phProcess ? *phProcess : GetCurrentProcess();
	
	//open the processes token
	
	if ( !OpenProcessToken ( hProcess, TOKEN_QUERY, &tok ) ) goto ert;
	
	//get the SID of the token
	ptu = ( TOKEN_USER* ) tubuf;
	
	if ( !GetTokenInformation ( tok, ( TOKEN_INFORMATION_CLASS ) 1, ptu, 300, &nlen ) ) goto ert;
	
	//get the account/domain name of the SID
	dlen = 300;
	
	nlen = 300;
	
	if ( !LookupAccountSid ( 0, ptu->User.Sid, name, &nlen, dom, &dlen, ( PSID_NAME_USE ) &iUse ) ) goto ert;
	
	//copy info to our static buffer
	if ( dlen && bIncDomain )
	{
		_tcscpy ( sname, dom );
		_tcscat ( sname, _T ( "" ) );
		_tcscat ( sname, name );
	}
	
	else
	{
		_tcscpy ( sname, name );
	}
	
	ret = TRUE;
	
ert:

	if ( tok ) CloseHandle ( tok );
	
	return ret;
}

/**
 *  explorer.exe  User SID(Security ID) ´. Ÿ ϰ ں Ʈ   Ѵ.
 * @param userSID - SID   
 * @return SID   ϸ TRUE, ƴϸ FALSE
 * @remark SID   ʱ  static  ĳϴ ڵ尡  ־ Ƽ ȯ濡  ȣ ÿ    ִ.
 *         Ƽ  ȯ濡 ȣÿ Լ ϱ Ѵ.
 */
BOOL CUtil::GetCurrentExplorerUserSID ( CAtlString& userSID )
{
	static CAtlString cachedUserSID;
	
	if ( cachedUserSID.IsEmpty() == FALSE )
	{
		userSID = cachedUserSID;
		return TRUE;
	}
	
	CTaskManager taskManager;
	
	CExeModuleInstance *pProcess;
	
	CAtlString logonUserName;
	GetVistaUserLogonName ( logonUserName );
	
	taskManager.Populate();
	
	for ( unsigned i = 0; i < taskManager.GetProcessCount(); i++ )
	{
		pProcess = taskManager.GetProcessByIndex ( i );
		
		CAtlString processName = pProcess->Get_Name();
		processName.MakeLower();
		
		if ( _tcsstr ( ( LPCTSTR ) processName, _T ( "explorer.exe" ) ) == 0 )
		{
			HANDLE hProcess = OpenProcess ( PROCESS_QUERY_INFORMATION, FALSE, pProcess->Get_ProcessId() );
			
			if ( hProcess == NULL )
			{
				continue;
			}
			
			TCHAR ownerName[300] = {0, };
			GetProcessUsername ( &hProcess, ownerName, FALSE );
			
			CloseHandle ( hProcess );
			
			if ( logonUserName != ownerName )
			{
				continue;
			}
			
			userSID = pProcess->Get_UserSID();
			
			cachedUserSID = userSID;
			
			return TRUE;
		}
	}
	
	return FALSE;
}

/**
 * Naver   Ȯϴ Լ, IsNaverUrlInternal  Լ̴.
 * @param url - Naver   θ  Url Ʈ
 * @return - Naver  ̸ TRUE, ƴϸ FALSE
 * @remart - Խ ̺귯 Ѱ Լ   ι ˻ϰ Ǿ ִ. www.naver.com www.naver.co.kr  θ  ˻ϴµ
 *            Խ ̺귯 ϸ ϳ 氡  Ѵ.(PCRE   ̺귯 )
 *           Naver ActiveX ̵忡  DLL ּȭϱ  PCRE   ʾҴ.
 */
BOOL CUtil::IsNaverUrl ( LPCTSTR url )
{
	if ( IsNaverUrlInternal ( url, _T ( "^(http:\\/\\/)*(www\\.)*naver\\.(com)+(\\/)*$" ) ) == FALSE )
	{
		return IsNaverUrlInternal ( url, _T ( "^(http:\\/\\/)*(www\\.)*naver\\.(co\\.kr)+(\\/)*$" ) );
	}
	
	else
	{
		return TRUE;
	}
}

/**
 *  Naver  ˻ϴ Լ
 * @param url - ˻ URL
 * @param regExp - ˻縦  Խ 
 * @return - Naver  ̸ TRUE, ƴϸ FALSE
 */
BOOL CUtil::IsNaverUrlInternal ( LPCTSTR url, const TCHAR* regExp )
{
	/*
	  νϴ ̽ :
	http://naver.com
	http://naver.com/
	http://www.naver.com
	http://www.naver.com/
	http://naver.co.kr
	http://naver.co.kr/
	naver.com
	naver.com/
	naver.co.kr
	naver.co.kr/
	http://www.naver.com/////////
	
	  ν ʴ ̽ :
	about:blank
	ttp://naver
	http://
	http://naver.
	http://www.daum.net
	www.daum.net
	daum.net
	www
	http://stock.naver.com
	       http://www.naver.or.kr
	*/
	
	// Խ ̿ؼ  ̽   νϴ ̽ match  Ȯϵ ó
	// match  naver   Ǿٰ 
#ifdef UNICODE
	CAtlRegExp<> regex;
	REParseError status = regex.Parse ( regExp, FALSE );
#else
	CAtlRegExp<CAtlRECharTraitsMB> regex;
	REParseError status = regex.Parse ( reinterpret_cast<const CAtlRegExp<CAtlRECharTraitsMB>::RECHAR*> ( regExp ), FALSE );
#endif
	
	if ( REPARSE_ERROR_OK != status )
	{
		//ASSERT(!_T("Regular Expression is not INVALID"));
		return FALSE;
	}
	
	else
	{
#ifdef UNICODE
		CAtlREMatchContext<> mc;
		
		if ( !regex.Match ( url, &mc ) )
#else
		CAtlREMatchContext<CAtlRECharTraitsMB> mc;
		
		if ( !regex.Match ( reinterpret_cast<const CAtlRegExp<CAtlRECharTraitsMB>::RECHAR*> ( url ), &mc ) )
#endif
		{
			// No match
			return FALSE;
		}
		else
		{
			// match
			return TRUE;
		}
	}
}

#include <WtsApi32.h>

/**
 * Vista  α Ǵϴ Լ (  α ƴ ǥ ڷ αߴ Ǵϱ )
 * @param isLogin -  α , TRUE   α, FALSE   α (out parameter)
 * @return    TRUE, ƴϸ FALSE
 * @remark 9X  ۵ϱ   εϴ ڵ带 ־. WTS API ̿
 *          α    ڸ Ѵ.   μ     ̵̹Ƿ
 *         α ڸ ٸ.  쿡 ǥ   αߴٰ ǴѴ.
 */
BOOL CUtil::IsVistaUserModeLogined ( BOOL& isLogin )
{
	BOOL  dwRet = FALSE;
	DWORD dwSessionID = -1; // 0 is 1st console session created on XP, 1 is 1st console session on Vista
	
	TCHAR* pData = NULL;
	DWORD cbReturned = 0;
	
	typedef BOOL ( WINAPI* FN_ProcessIdToSessionId ) ( DWORD dwProcessId, DWORD *pSessionId );
	typedef BOOL ( WINAPI* FN_WTSQuerySessionInformation ) ( HANDLE hServer, DWORD SessionId, WTS_INFO_CLASS WTSInfoClass, TCHAR** ppBuffer, DWORD * pBytesReturned );
	typedef VOID ( WINAPI* FN_WTSFreeMemory ) ( PVOID pMemory );
	
	HMODULE hKernel = NULL;
	HMODULE hWts = NULL;
	
	FN_ProcessIdToSessionId         pProcessIdToSessionId = NULL;
	FN_WTSQuerySessionInformation  pWTSQuerySessionInformation = NULL;
	FN_WTSFreeMemory                pWTSFreeMemroy = NULL;
	
	hKernel = LoadLibrary ( _T ( "Kernel32.dll" ) );
	hWts    = LoadLibrary ( _T ( "WtsApi32.dll" ) );
	
	if ( hKernel == NULL || hWts == NULL )
	{
		dwRet = FALSE;
		goto exit;
	}
	
	pProcessIdToSessionId = ( FN_ProcessIdToSessionId ) GetProcAddress ( hKernel, "ProcessIdToSessionId" );
	
	pWTSQuerySessionInformation = ( FN_WTSQuerySessionInformation ) GetProcAddress ( hWts, "WTSQuerySessionInformation" );
	pWTSFreeMemroy = ( FN_WTSFreeMemory ) GetProcAddress ( hWts, "WTSFreeMemory" );
	
	if ( pProcessIdToSessionId == NULL || pWTSQuerySessionInformation == NULL || pWTSFreeMemroy == NULL )
	{
		dwRet = FALSE;
		goto exit;
	}
	
	pProcessIdToSessionId ( GetCurrentProcessId(), &dwSessionID );
	
	if ( pWTSQuerySessionInformation ( WTS_CURRENT_SERVER_HANDLE, dwSessionID, WTSUserName, &pData, &cbReturned ) )
	{
		TCHAR userName[256 +1];
		DWORD dwData = sizeof ( userName );
		GetUserName ( userName, &dwData );
		
		isLogin = ( _tcscmp ( pData, userName ) != 0 );
		
		dwRet = TRUE;
	}
	
	pWTSFreeMemroy ( pData );
	
exit:

	if ( hKernel )
	{
		FreeLibrary ( hKernel );
		hKernel = NULL;
	}
	
	if ( hWts )
	{
		FreeLibrary ( hWts );
		hWts = NULL;
	}
	
	return dwRet;
}

/**
 * Vista α ڸ  Լ
 * @param  userName - α ڸ  (out parameter)
 * @return    TRUE, ƴϸ FALSE
 * @remark 9X  ۵ϱ   εϴ ڵ带 ־.
 */
BOOL CUtil::GetVistaUserLogonName ( CAtlString& userName )
{
	BOOL  dwRet = FALSE;
	DWORD dwSessionID = -1; // 0 is 1st console session created on XP, 1 is 1st console session on Vista
	
	LPTSTR pData = NULL;
	DWORD cbReturned = 0;
	
	typedef BOOL ( WINAPI* FN_ProcessIdToSessionId ) ( DWORD dwProcessId, DWORD *pSessionId );
	typedef BOOL ( WINAPI* FN_WTSQuerySessionInformation ) ( HANDLE hServer, DWORD SessionId, WTS_INFO_CLASS WTSInfoClass, TCHAR** ppBuffer, DWORD * pBytesReturned );
	typedef VOID ( WINAPI* FN_WTSFreeMemory ) ( PVOID pMemory );
	
	HMODULE hKernel = NULL;
	HMODULE hWts = NULL;
	
	FN_ProcessIdToSessionId         pProcessIdToSessionId = NULL;
	FN_WTSQuerySessionInformation  pWTSQuerySessionInformation = NULL;
	FN_WTSFreeMemory                pWTSFreeMemroy = NULL;
	
	hKernel = LoadLibrary ( _T ( "Kernel32.dll" ) );
	hWts    = LoadLibrary ( _T ( "WtsApi32.dll" ) );
	
	if ( hKernel == NULL || hWts == NULL )
	{
		dwRet = FALSE;
		goto exit;
	}
	
	pProcessIdToSessionId = ( FN_ProcessIdToSessionId ) GetProcAddress ( hKernel, "ProcessIdToSessionId" );
	
	pWTSQuerySessionInformation = ( FN_WTSQuerySessionInformation ) GetProcAddress ( hWts, "WTSQuerySessionInformation" );
	pWTSFreeMemroy = ( FN_WTSFreeMemory ) GetProcAddress ( hWts, "WTSFreeMemory" );
	
	if ( pProcessIdToSessionId == NULL || pWTSQuerySessionInformation == NULL || pWTSFreeMemroy == NULL )
	{
		dwRet = FALSE;
		goto exit;
	}
	
	pProcessIdToSessionId ( GetCurrentProcessId(), &dwSessionID );
	
	if ( pWTSQuerySessionInformation ( WTS_CURRENT_SERVER_HANDLE, dwSessionID, WTSUserName, &pData, &cbReturned ) )
	{
		userName = pData;
		
		dwRet = TRUE;
	}
	
	pWTSFreeMemroy ( pData );
	
exit:

	if ( hKernel )
	{
		FreeLibrary ( hKernel );
		hKernel = NULL;
	}
	
	if ( hWts )
	{
		FreeLibrary ( hWts );
		hWts = NULL;
	}
	
	return dwRet;
}

/**
 * ̹  Ǿ ִ θ ϴ Լ
 * @return ̹  Ǿ   TRUE, ƴϸ FALSE
 * @remark IE7      ִµ,      ϳ ̹ ̸
 *         Ǿ ִ  .
 */
BOOL CUtil::IsNaverStartPageConfigured()
{
	CRegKey regkey;
	
	HKEY    hParent = HKEY_CURRENT_USER;
	CAtlString keyName = _T ( "SOFTWARE\\Microsoft\\Internet Explorer\\Main" );
	
	if ( IsWinVista() == TRUE )
	{
		BOOL isVistaUserModeLogin = FALSE;
		
		IsVistaUserModeLogined ( isVistaUserModeLogin );
		
		if ( isVistaUserModeLogin == TRUE )
		{
			CAtlString userSid;
			GetCurrentExplorerUserSID ( userSid );
			
			CAtlString keyNameTemp;
			keyNameTemp.Format ( _T ( "%s\\%s" ), userSid, keyName );
			
			hParent = HKEY_USERS;
			keyName = keyNameTemp;
		}
	}
	
	
	if ( regkey.Open ( hParent, keyName, KEY_READ ) != ERROR_SUCCESS )
	{
		if ( regkey.Open ( hParent, keyName, KEY_READ | KEY_WOW64_64KEY ) != ERROR_SUCCESS )
		{
			return FALSE;
		}
	}
	
	
	// NOTE : Max Length of IE's URL is 2083
	TCHAR szStartPage[2083] = {0, };
	
	ULONG nChars = sizeof ( szStartPage );
	
	// Start Page     ְ, ̸ ϸ IE   ٲ
	if ( ERROR_SUCCESS == regkey.QueryStringValue ( _T ( "Start Page" ), szStartPage, &nChars ) )
	{
		if ( IsNaverUrl ( szStartPage ) == TRUE )
		{
			return TRUE;
		}
		
		else
		{
			TCHAR *szStartPages;
			szStartPages = new TCHAR[32000];
			memset ( szStartPages, 0, 32000 * sizeof ( TCHAR ) );
			
			ULONG nChars = 32000 * sizeof ( TCHAR );
			
			if ( ERROR_SUCCESS == regkey.QueryMultiStringValue ( _T ( "Secondary Start Pages" ), szStartPages, &nChars ) )
			{
				TCHAR *pStr = szStartPages;
				
				while ( *pStr != '\0' )
				{
					if ( IsNaverUrl ( pStr ) == TRUE )
					{
						delete[] szStartPages;
						return TRUE;
					}
					
					pStr = pStr + lstrlen ( pStr );
					
					pStr++;
				}
				
				delete[] szStartPages;
				
				return FALSE;
			}
			
			else
			{
				delete[] szStartPages;
				return FALSE;
			}
		}
	}
	
	else
	{
		return FALSE;
	}
}

/**
 * IsNaverSearchEngineConfigured(), SetNaverSearchEngine()  ϴ Լ,  ˻ Provider   Naver  ȮѴ.
 * @return ⺻ ˻ ̸̹ TRUE, ƴϸ FALSE
 */
BOOL CUtil::IsNaverProvider ( LPCTSTR szDefaultScope )
{
	if ( szDefaultScope == NULL )
	{
		return FALSE;
	}
	
	CRegKey scopeKey;
	
	CAtlString searchScopeProvider;
	searchScopeProvider.Format ( _T ( "SOFTWARE\\Microsoft\\Internet Explorer\\SearchScopes\\%s" ), szDefaultScope );
	
	HKEY    hParent = HKEY_CURRENT_USER;
	CAtlString keyName = searchScopeProvider;
	
	if ( IsWinVista() == TRUE )
	{
		BOOL isVistaUserModeLogin = FALSE;
		
		IsVistaUserModeLogined ( isVistaUserModeLogin );
		
		if ( isVistaUserModeLogin == TRUE )
		{
			CAtlString userSid;
			GetCurrentExplorerUserSID ( userSid );
			
			CAtlString keyNameTemp;
			keyNameTemp.Format ( _T ( "%s\\%s" ), userSid, keyName );
			
			hParent = HKEY_USERS;
			keyName = keyNameTemp;
		}
	}
	
	LONG ret = ERROR_SUCCESS;
	
	if ( ( ret = scopeKey.Open ( hParent,  keyName, KEY_READ ) ) != ERROR_SUCCESS )
	{
		if ( ( ret = scopeKey.Open ( hParent,  keyName, KEY_READ | KEY_WOW64_64KEY ) ) != ERROR_SUCCESS )
		{
			return FALSE;
		}
	}
	
	TCHAR displayName[255];
	
	ULONG nChars = sizeof ( displayName );
	
	if ( ERROR_SUCCESS != scopeKey.QueryStringValue ( _T ( "DisplayName" ), displayName, &nChars ) )
	{
		return FALSE;
	}
	
	if ( _tcsicmp ( displayName, _T ( "Naver" ) ) == 0 )
	{
		return TRUE;
	}
	
	else
	{
		return FALSE;
	}
}

/**
 * ⺻ ˻ ̹ Ȯϴ Լ (IE7  ǹ̰ )
 * @return ⺻ ˻ ̸̹ TRUE, ƴϸ FALSE
 */
BOOL CUtil::IsNaverSearchEngineConfigured()
{
	CRegKey regkey;
	
	HKEY    hParent = HKEY_CURRENT_USER;
	CAtlString keyName =  _T ( "SOFTWARE\\Microsoft\\Internet Explorer\\SearchScopes" );
	
	if ( IsWinVista() == TRUE )
	{
		BOOL isVistaUserModeLogin = FALSE;
		
		IsVistaUserModeLogined ( isVistaUserModeLogin );
		
		if ( isVistaUserModeLogin == TRUE )
		{
			CAtlString userSid;
			GetCurrentExplorerUserSID ( userSid );
			
			CAtlString keyNameTemp;
			keyNameTemp.Format ( _T ( "%s\\%s" ), userSid, keyName );
			
			hParent = HKEY_USERS;
			keyName = keyNameTemp;
		}
	}
	
	if ( regkey.Open ( hParent, keyName, KEY_READ ) != ERROR_SUCCESS )
	{
		if ( regkey.Open ( hParent, keyName, KEY_READ | KEY_WOW64_64KEY ) != ERROR_SUCCESS )
		{
			return FALSE;
		}
	}
	
	TCHAR szDefaultScope[255] = {0, };
	ULONG nChars = sizeof ( szDefaultScope );
	
	// DefaultScope ׸ ⺻ ˻   GUID   
	
	if ( ERROR_SUCCESS != regkey.QueryStringValue ( _T ( "DefaultScope" ), szDefaultScope, &nChars ) )
	{
		return FALSE;
	}
	
	// GUID  شǴ Ű ٽ   ׸ DisplayName  Naver  Ȯ
	return IsNaverProvider ( szDefaultScope );
}

/**
 * Naver   ϴ Լ
 * @return  ϸ TRUE, ƴϸ FALSE
 * @remark    쿡  ó ׸ http://www.naver.com/  Ѵ.
 */
BOOL CUtil::SetNaverStartPage()
{
	CRegKey regkey;
	
	HKEY    hParent = HKEY_CURRENT_USER;
	CAtlString keyName = _T ( "SOFTWARE\\Microsoft\\Internet Explorer\\Main" );
	
	if ( IsWinVista() == TRUE )
	{
		BOOL isVistaUserModeLogin = FALSE;
		
		IsVistaUserModeLogined ( isVistaUserModeLogin );
		
		if ( isVistaUserModeLogin == TRUE )
		{
			CAtlString userSid;
			GetCurrentExplorerUserSID ( userSid );
			
			CAtlString keyNameTemp;
			keyNameTemp.Format ( _T ( "%s\\%s" ), userSid, keyName );
			
			hParent = HKEY_USERS;
			keyName = keyNameTemp;
		}
	}
	
	if ( regkey.Open ( hParent, keyName ) != ERROR_SUCCESS )
	{
		if ( regkey.Open ( hParent, keyName, KEY_WOW64_64KEY) != ERROR_SUCCESS )
		{
			return FALSE;
		}
	}
	
	// Start Page  "http://www.naver.com/" 
	
	if ( ERROR_SUCCESS == regkey.SetStringValue ( _T ( "Start Page" ), _T ( "http://www.naver.com/" ) ) )
	{
		return TRUE;
	}
	
	else
	{
		return FALSE;
	}
}

/**
 * Naver  ⺻ ˻ ϴ Լ
 * @return  ϸ TRUE, ƴϸ FALSE
 */
BOOL CUtil::SetNaverSearchEngine()
{
	// Naver ˻  شǴ  Ѵٸ װɷ ϰ
	// ƴϸ    ְ ̸ ⺻ ˻  
	CRegKey regkey;
	
	HKEY    hParent = HKEY_CURRENT_USER;
	CAtlString keyName = _T ( "SOFTWARE\\Microsoft\\Internet Explorer\\SearchScopes" );
	
	if ( IsWinVista() == TRUE )
	{
		BOOL isVistaUserModeLogin = FALSE;
		
		IsVistaUserModeLogined ( isVistaUserModeLogin );
		
		if ( isVistaUserModeLogin == TRUE )
		{
			CAtlString userSid;
			GetCurrentExplorerUserSID ( userSid );
			
			CAtlString keyNameTemp;
			keyNameTemp.Format ( _T ( "%s\\%s" ), userSid, keyName );
			
			hParent = HKEY_USERS;
			keyName = keyNameTemp;
		}
	}
	
	if ( regkey.Open ( hParent, keyName ) != ERROR_SUCCESS )
	{
		if ( regkey.Open ( hParent, keyName, KEY_WOW64_64KEY ) != ERROR_SUCCESS )
		{
			return FALSE;
		}
	}
	
	int iIndex = 0;
	
	while ( TRUE )
	{
		TCHAR szProviderGUID[255];
		DWORD dwProviderGUIDLength = sizeof ( szProviderGUID );
		
		LONG ret = regkey.EnumKey ( iIndex, szProviderGUID, &dwProviderGUIDLength );
		
		if ( ret == ERROR_SUCCESS || ret == ERROR_MORE_DATA )
		{
			szProviderGUID[dwProviderGUIDLength] = '\0';
			
			if ( IsNaverProvider ( szProviderGUID ) == TRUE )
			{
				// ̰ɷ ⺻ ˻  
				if ( ERROR_SUCCESS == regkey.SetStringValue ( _T ( "DefaultScope" ), szProviderGUID ) )
				{
					return TRUE;
				}
				
				else
				{
					return FALSE;
				}
			}
			
			++iIndex;
		}
		
		else if ( ret == ERROR_NO_MORE_ITEMS )
		{
			break;
		}
		
		else
		{
			return FALSE;
		}
	}
	
	// ƿ      װɷ 
	CAtlString strGUID;
	
	GUID Guid;
	
	HRESULT hResult = ::CoCreateGuid ( &Guid );
	
	if ( SUCCEEDED ( hResult ) )
	{
		strGUID.Format ( _T ( "{%.8X-%.4X-%.4X-%.2X%.2X-%.2X%.2X%.2X%.2X%.2X%.2X}" ),
						 Guid.Data1, Guid.Data2, Guid.Data3,
						 Guid.Data4[ 0 ], Guid.Data4[ 1 ], Guid.Data4[ 2 ],
						 Guid.Data4[ 3 ], Guid.Data4[ 4 ], Guid.Data4[ 5 ],
						 Guid.Data4[ 6 ], Guid.Data4[ 7 ] );
	}
	
	CRegKey newProviderKey;
	
	if ( newProviderKey.Create ( regkey, strGUID ) != ERROR_SUCCESS )
	{
		return FALSE;
	}
	
	newProviderKey.SetStringValue ( _T ( "DisplayName" ), _T ( "Naver" ) );
	newProviderKey.SetStringValue ( _T ( "URL" ), SEARCH_URL );
	newProviderKey.SetDWORDValue ( _T ( "Codepage" ), CODE_PAGE );
	newProviderKey.SetStringValue ( _T ( "SuggestionsURL_JSON" ), SUGGESTION_URL_JASON );
	newProviderKey.SetDWORDValue ( _T ( "ShowSearchSuggestions" ), SHOW_SEARCH_SUGGESTION );

	if ( IsIEVersionRequiredOrHigherVer ( IE_VERSION_8 ) == TRUE )
	{
		newProviderKey.SetStringValue ( _T ( "FaviconURL" ), FAVICON_URL );
	}
	
	// ̰ɷ ⺻ ˻  
	
	if ( ERROR_SUCCESS == regkey.SetStringValue ( _T ( "DefaultScope" ), strGUID ) )
	{
		return TRUE;
	}
	
	else
	{
		return FALSE;
	}
}

/**
*@fn static BOOL FixInvalidNaverSearchScope();
*@param ˻ ڿ Naver ִٸ ش  ùٸ   Ѵ.
**/
BOOL CUtil::FixInvalidNaverSearchScope()
{
	CRegKey regkey;

	HKEY    hParent = HKEY_CURRENT_USER;
	CAtlString keyName = _T ( "SOFTWARE\\Microsoft\\Internet Explorer\\SearchScopes" );

	if (TRUE == IsWinVista() )
	{
		CreateUserModeKey(keyName, hParent);
	}

	if ( ERROR_SUCCESS != regkey.Open ( hParent, keyName )  )
	{
		if ( ERROR_SUCCESS != regkey.Open ( hParent, keyName , KEY_WOW64_64KEY)  )
		{
			return FALSE;
		}
	}

	int iIndex = 0;
	TCHAR szProviderGUID[255] = {0x00};
	DWORD dwProviderGUIDSize = sizeof(szProviderGUID);;
	CRegKey oldProviderKey;
	BOOL bMSProvideUrl = FALSE;
	/************************************************************************/
	/* 
	   SearchScope  GUID  Žϸ鼭 URL ̹ ˻ ڸ ã´.
	   ߸Ǿ  Ѵ.
	   
	   @ 
	   1. URL   URL ٸ ( 3 ̽)
	   2. CodePage ߸ (̽ 2 Ȯ)
	*/
	/************************************************************************/
	while ( TRUE )
	{
		LONG ret = regkey.EnumKey ( iIndex, szProviderGUID, &dwProviderGUIDSize );
		if (  ERROR_SUCCESS == ret ||  ERROR_MORE_DATA == ret )
		{
			szProviderGUID[dwProviderGUIDSize] = '\0';
	
			if ( TRUE == IsNaverProvider ( szProviderGUID ) ) 
			{	
				//˻ ڰ Naver 

				if ( ERROR_SUCCESS != oldProviderKey.Create ( regkey, szProviderGUID ) )
				{
					continue;
				} 

				bMSProvideUrl = FALSE;
				if ( FALSE == IsValidSearchScope( oldProviderKey, bMSProvideUrl ) )
				{
					WriteValidSearchScopeInfo( oldProviderKey, bMSProvideUrl );
				}
				oldProviderKey.Close();
			}

			++iIndex;
		}
		else if ( ERROR_NO_MORE_ITEMS  == ret )
		{
			break;
		}
		else
		{
			return FALSE;
		}

		ZeroMemory( szProviderGUID, 255 );
		dwProviderGUIDSize = sizeof(szProviderGUID);
	}

	return TRUE;

}

BOOL CUtil::IsValidSearchScope( CRegKey &regProviderKey, /*OUT*/ BOOL &bMSProvideUrl )
{
	BOOL bRet = TRUE;
	TCHAR szRegValue[MAX_PATH * 4] = {0x00};

	DWORD dwRegValueSize = sizeof(szRegValue);
	DWORD dwValue = 0;

	if ( TRUE == IsIEVersionRequiredOrHigherVer ( IE_VERSION_8 ) )
	{
		regProviderKey.QueryStringValue( _T ( "FaviconURL" ), szRegValue, &dwRegValueSize );
		if( 0 != _tcscmp( szRegValue, FAVICON_URL ) )
		{
			regProviderKey.SetStringValue ( _T ( "FaviconURL" ), FAVICON_URL );
		}
	}

	szRegValue[0] = 0x00;
	dwRegValueSize = sizeof(szRegValue);
	regProviderKey.QueryStringValue( _T("URL"), szRegValue, &dwRegValueSize );

	//߸ URL Ȯ
	for( int i = 0 ; i < MAX_INVALID_URL_COUNT ; i++ )
	{
		if( 0 == _tcscmp( szRegValue, g_szInvalidSearchUrl[i] ) )
		{
			if (MS_GALLERY_URL_NO > i )
			{
				bRet = FALSE;
			}
			else if( MS_GALLERY_URL_NO == i) //MS  URL
			{
				bRet = FALSE;
				bMSProvideUrl = TRUE;
			}
			else if( MS_GALLERY_URL_NO < i )
			{
				regProviderKey.QueryDWORDValue( _T("Codepage"), dwValue );
				if( dwValue != CODE_PAGE )
				{
					bRet = FALSE;
				}
			}
		}
	}


	return bRet;

}

void CUtil::WriteValidSearchScopeInfo(CRegKey &oldProviderKey, BOOL bMSProvideUrl )
{
	/************************************************************************/
	/* 
	MS_Gallery   ̹    URL 쿡 
	  ٸ
	*/
	/************************************************************************/

	if( bMSProvideUrl )
	{
		oldProviderKey.SetStringValue( _T ( "URL" ), SEARCH_URL_FOR_MS );	
	}
	else
	{	
		// ̹ ˻   
		oldProviderKey.SetStringValue( _T ( "URL" ), SEARCH_URL );
	}

	oldProviderKey.SetDWORDValue ( _T ( "Codepage" ), CODE_PAGE );				
	oldProviderKey.SetStringValue ( _T ( "SuggestionsURL_JSON" ), SUGGESTION_URL_JASON );				
	oldProviderKey.SetDWORDValue ( _T ( "ShowSearchSuggestions" ), SHOW_SEARCH_SUGGESTION );

}

void CUtil::CreateUserModeKey( /*OUT*/ CAtlString &strKeyName, HKEY /*OUT*/ &hParent )
{
	/************************************************************************/
	/*  Vista ̻  UserMode User                      
	   SearchScope  ġ ٸ  ýũ ڿ Ű . 

	   Key  ġ : HKEY_USER\\USERSID\\SOFTWARE\\Microsoft\\
	   Internet Explorer\\SearchScopes
	*/
	/************************************************************************/
	BOOL isVistaUserModeLogin = FALSE;

	IsVistaUserModeLogined ( isVistaUserModeLogin );

	if ( TRUE == isVistaUserModeLogin )
	{
		CAtlString userSid;
		GetCurrentExplorerUserSID ( userSid );

		CAtlString keyNameTemp;
		keyNameTemp.Format ( _T ( "%s\\%s" ), userSid, strKeyName );

		hParent = HKEY_USERS;
		strKeyName = keyNameTemp;
	}
}

BOOL CUtil::IsWow64()
{	
	typedef BOOL (WINAPI *LPFN_ISWOW64PROCESS) (HANDLE, PBOOL);

	LPFN_ISWOW64PROCESS fnIsWow64Process = NULL;

	BOOL bIsWow64 = FALSE;

	//IsWow64Process is not available on all supported versions of Windows.
	//Use GetModuleHandle to get a handle to the DLL that contains the function
	//and GetProcAddress to get a pointer to the function if available.

	fnIsWow64Process = (LPFN_ISWOW64PROCESS) GetProcAddress( GetModuleHandle(TEXT("kernel32")), "IsWow64Process");

	if(NULL != fnIsWow64Process)
	{
		if (!fnIsWow64Process(GetCurrentProcess(),&bIsWow64))
		{
			//handle error
		}
	}

	return bIsWow64;
}
